clear all
close all

a=0.0;
b=2*pi;
c2=0.0;
d=2*pi;

nplus1=320;
%nplus1=40;
%nplus1=80;
%nplus1=160;
n=nplus1-1;
diffcoe=0.2;
h=(b-a)/(n+1);
c=diffcoe/h/h;    
X=zeros(n,n+1);
Y=zeros(n,n+1);
U=zeros(n,n+1);
TermK=zeros(n,n+1);
U2=zeros(n,n+1);

for i=1:n
    X(i,:)=i*h;
end

for j=1:nplus1
    Y(:,j)=j*h;
end

U=init(X,Y);
DA=zeros(n,n);
DB=zeros(nplus1,nplus1);

DA(1,1)=-2.0/3.0;
DA(1,2)=2.0/3.0;
DA(n,n-1)=2.0/3.0;
DA(n,n)=-2.0/3.0;
for k=2:n-1
    DA(k,k)=-2.0;
    DA(k,k-1)=1.0;
    DA(k,k+1)=1.0;
end
DA=c*DA;

DB(1,1)=-2.0;
DB(1,2)=1.0;
DB(1,nplus1)=1.0;
DB(nplus1,1)=1.0;
DB(nplus1,n)=1.0;
DB(nplus1,nplus1)=-2.0;
for k=2:n
    DB(k,k)=-2.0;
    DB(k,k-1)=1.0;
    DB(k,k+1)=1.0;
end
DB=c*DB;

ttt4=cputime;

dt=h*h;

tend=1.0;
tnum=0.0;
istop=0;

while istop==0
    if(tnum+dt > tend)
        dt=tend-tnum;
        istop=1;
    end
    
    TermK=U+dt*(DA*U+U*DB+f(U));
    
    U2=(U+TermK+dt*(DA*TermK+TermK*DB+f(TermK)))/2.0;
    
    U=U2;
    
    tnum=tnum+dt;
end

format long
cpu_time = cputime-ttt4

Uexact=exact(X, Y, tend);

error=max(max(U-Uexact))    
            
    
    
